<template>
  <appTable center-header :headers="['Turnos Asignados', ...headers]">
    <template #body>
      <tr v-for="(item, index) in bodyList" :key="index">
        <appTableTd v-for="turn in item" :key="turn.id">
          <div class="text-sm text-gray-900">
            {{ tableText(turn).title }}
          </div>
          <div class="text-sm text-gray-500">
            {{ tableText(turn).subtitle }}
          </div>
        </appTableTd>
      </tr>
    </template>
  </appTable>
</template>

<script>
import apiMixin from '../../mixins/api';
export default {
  name: 'assignedShift',
  mixins: [apiMixin],
  computed: {
    headers() {
      const result = [...this.turnsListAssigned].map(({ date }) => date);
      return [...new Set(result)];
    },
    bodyList() {
      const group = this.groupTurnsUsingUserNameAsKey();
      const result = [];
      Object.keys(group).forEach((userFullNameKey) => {
        const newRow = this.relocateDatesFromRow(group[userFullNameKey]);
        result.push([userFullNameKey, ...newRow]);
      });
      return result;
    },
  },
  methods: {
    relocateDatesFromRow(turnRow) {
      const result = new Array(this.headers.length);
      this.headers.forEach((headerDate, index) => {
        const turn = turnRow.find(({ date }) => date === headerDate);
        result[index] = turn || {};
      });
      return result;
    },
    groupTurnsUsingUserNameAsKey() {
      const result = {};
      this.userList.forEach((user) => {
        const userTurns = this.getTurnsFromUser(user);
        if (userTurns.length > 0) {
          result[this.fullName(user)] = userTurns;
        }
      });
      return result;
    },
    fullName(user) {
      return `${user.firstName} ${user.lastName}`;
    },
    getTurnsFromUser({ id }) {
      return this.turnsListAssigned.filter(({ userId }) => {
        return !!(userId || []).find((turnUserId) => turnUserId === id);
      });
    },
    tableText(turn) {
      if (typeof turn === 'string') {
        return { title: turn };
      }
      const { turnTemplateId } = turn;
      const { name, checkIn, checkOut } =
        this.turnsTemplateList.find(({ id }) => id === turnTemplateId) || {};
      const found = name && checkIn && checkOut;
      const title = found ? `${name}` : '';

      const subtitle = found ? `(${checkIn}-${checkOut})` : '';
      return { title, subtitle };
    },
  },
};
</script>

<style></style>
